const cls = require("cls-hooked");
const uuid = require("uuid");
const CONTEXT_ID = "CONTEXT_ID";
const CONTEXT = "CONTEXT";
const context = cls.createNamespace(CONTEXT);
const set = (callback, eventEmitters) => {
    const contextId = uuid.v1();
    if (eventEmitters) {
        for (const em of eventEmitters) {
            context.bindEmitter(em);
        }
    }
    context.run(() => {
        context.set(CONTEXT_ID, contextId);
        callback();
    });
};
const get = () => {
    const currentContext = cls.getNamespace(CONTEXT);
    const contextName = currentContext.get(CONTEXT_ID);
    return contextName ? contextName : "no context";
};
module.exports = { set, get };
